#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdint.h>
#include <inttypes.h>

int usage(char *argv0, char *msg)
{
	fprintf(stderr,
		"Copyright (C) 2014, Michael Gruhn <michael.gruhn@cs.fau.de>\n"
		"No rights reserved.\n"
		"\n"
		"usage: %s <offset> <start>\n"
		"\tskip\tnumber of bytes to skip at beginning of file\n"
		"\n"
		"Error: %s\n"
		, argv0, msg);
	return 1;
}


int die(char *msg)
{
	fprintf(stderr, "ERROR: %s\n", msg);
	return 1;
}


int main(int argc, char *argv[])
{
	if(argc != 3)
		return usage(argv[0], "Argument count mismatch!");

	uint32_t v=0;
	uint64_t i=0;
	uint64_t l=0;
	uint64_t skip = strtoll(argv[1],NULL,16);
	uint64_t start = strtoll(argv[2],NULL,16);
	uint32_t next=start;

	for(i=0; i < skip; i++)
		getchar();

	while( fread(&v, sizeof(v), 1, stdin)==1 )
	{
restart:
		i+=sizeof(v);
		if( v == start )
		{
			uint64_t s = i-sizeof(v);
			l=1;
			next=start+1;
			while( fread(&v, sizeof(v), 1, stdin)==1 && v==next)
			{
				i+=sizeof(v);
				next++;
				l++;
			}
			if(l>=0x400)
			{
				printf("0x%08"PRIx32"=0x%08"PRIx32"\n",v,next);
				printf("start found @ 0x%016"PRIx64" (0x%"PRIx64")\n", s, l*4/1024);
			}
			if( feof(stdin) ) break;
			goto restart;
		}
	}

	return 0;
}

