#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdint.h>
#include <inttypes.h>

int usage(char *argv0, char *msg)
{
	fprintf(stderr,
		"Copyright (C) 2014, Michael Gruhn <michael.gruhn@cs.fau.de>\n"
		"No rights reserved.\n"
		"\n"
		"usage: %s <offset>\n"
		"\tskip\tnumber of bytes to skip at beginning of file\n"
		"\n"
		"Error: %s\n"
		, argv0, msg);
	return 1;
}


int die(char *msg)
{
	fprintf(stderr, "ERROR: %s\n", msg);
	return 1;
}


int main(int argc, char *argv[])
{
	if(argc != 2)
		return usage(argv[0], "Argument count mismatch!");

	uint32_t old=-1;
	uint32_t base=0;
	uint32_t longest_base=0;
	uint32_t v=0;
	uint64_t i=0;
	uint64_t match=1;
	uint64_t longest_match=0;

	long skip = strtol(argv[1],NULL,16);
	uint64_t base_addr=skip;
	uint64_t longest_base_addr=skip;

	for(i=0; i < skip; i++)
		getchar();

	while( fread(&v, sizeof(v), 1, stdin)==1 )
	{
		if( old+1 == v ) match++;
		else
		{
			if( match > longest_match)
			{
				longest_match = match;
				longest_base = base;
				longest_base_addr = base_addr;
			}
			match = 1;
			base = v;
			base_addr = i;
		}
		old = v;
		i+=sizeof(v);
	}
	if( match > longest_match)
	{
		longest_match = match;
		longest_base = base;
		longest_base_addr = base_addr;
	}

	printf("longest match 0x%"PRIx64" = 0x%"PRIx64" KiB starting with 0x%08"PRIx32" @ 0x%016"PRIx64"\n", longest_match*4, (longest_match*4)/1024, longest_base, longest_base_addr);

	return 0;
}

