#!/bin/bash
if [ $# -ne 8 ]; then
	echo "usage: gem.sh <vmname> <mem> <alloc> <mode> <addr> <volatility-2.4_path> <volatiliy_profile> <RAM in MiB>"
# example:
# ./gem.sh pagefile.sys 128 malloc addr 0x06495430 ../volatility-2.4 Win7SP1x86 512
	exit
fi
vmname=$1
mem=$2
alloc=$3
mode=$4
addr=$5
volpath="$6/vol.py"
volprofile=$7 # Win7SP1x86
rammib=$8
path="${mem}_${alloc}_${mode}_${addr}_${volprofile}_${rammib}"
mkdir ${path}
vboxmanage debugvm ${vmname} dumpguestcore --filename ram.elf64
vboxmanage controlvm ${vmname} savestate
hdduid=$(vboxmanage showvminfo ${vmname} | grep 'SATA (0' | sed 's/.*UUID: \([^)]*\))/\1/')
vboxmanage clonehd --format raw ${hdduid} disk.dd
vboxmanage closemedium disk disk.dd
icat_offset=$(mmls disk.dd | grep 00:01 | awk '{print $3}')
icat_inode_of_pagefile=$(fls -o ${icat_offset} disk.dd | grep pagefile.sys | grep -v "\*" | awk '{print $2}' | sed 's/://')
icat -o ${icat_offset} disk.dd ${icat_inode_of_pagefile} > ${path}/pagefile.sys
python2 ${volpath} -f ram.elf64 imagecopy -O ram.dd
dd if=ram.dd of=${path}/phyram.dd bs=1M count=${rammib}
rm disk.dd
rm ram.dd
rm ram.elf64
pid=$(python2 ${volpath} --profile ${volprofile} -f ${path}/phyram.dd pslist | grep ramwrite.exe | awk '{print $3}')
python2 ${volpath} --profile ${volprofile} -f ${path}/phyram.dd -p ${pid} memmap > ${path}/memmap.txt
python2 ${volpath} --profile ${volprofile} -f ${path}/phyram.dd -p ${pid} memdump --dump-dir ${path}

